// Square.cs

using System;

public class Square
{
	private int m_size;
	private int m_origin;
	private bool m_isSolid;
	public Square(int size)
	{
		m_size = size;
		m_origin = 0;
		m_isSolid = true;
	}
	private void ShowOutline()
	{
		if (m_size == 0)
			return;
		if ( m_size == 1)
		{
			Console.WriteLine("*");
			return;
		}
		for (int i = 0; i < m_size; i++)
		{ 
			for (int k = 0; k < m_origin; k++)
				Console.Write(" ");
			Console.Write("*");
			for (int j = 1; j < m_size - 1; j++)
			{
				if (i == 0 || i == m_size - 1)
					Console.Write("*");
				else
					Console.Write(" ");
			}
			Console.Write("*");
			Console.WriteLine();
		}
	}
	private void ShowSolid()
	{
		for (int i = 0; i < m_size; i++)
		{ 
			for (int k = 0; k < m_origin; k++)
				Console.Write(" ");
			for (int j = 0; j < m_size; j++)
				Console.Write("*");
			Console.WriteLine();
		}
	}
	public void Show()
	{
		if (m_isSolid)
			ShowSolid();
		else
			ShowOutline();
	}
	public void SetSize(int s)
	{
		m_size = s;
	}
	public int GetSize()
	{
		return m_size;
	}
	public void Move(int x)
	{
		m_origin += x;
		if (m_origin < 0)
			m_origin = 0;
	}
	public int GetOrigin()
	{
		return m_origin;
	}
	public void SetSolid(bool isSolid)
	{
		m_isSolid = isSolid;
	}
}