// InputType.cs
//
// Demonstrates inputting various types
// Also illustrates testing for string command input
//
// Implements the following commands:
//      int			input an int
//      double		input a double
//      decimal		input a decimal
//      string		input a string
//      quit        exit the program
//
using System;

class ShapeDemo
{
	public static void Main()
	{
		InputWrapper iw = new InputWrapper();
		string cmd = iw.getString("> ");
		while (! cmd.Equals("quit"))
		{
			if (cmd.Equals("int"))
			{
				int i = iw.getInt("enter integer: ");
				Console.WriteLine("i = {0}",i);
			}
			else if (cmd.Equals("double"))
			{
				double d = iw.getDouble("enter double: ");
				Console.WriteLine("d = {0}",d);
			}
			else if (cmd.Equals("decimal"))
			{
				decimal dec = iw.getDecimal("enter decimal: ");
				Console.WriteLine("dec = {0}",dec);
			}
			else if (cmd.Equals("string"))
			{
				string s = iw.getString("enter string: ");
				Console.WriteLine("s = {0}",s);
			}
			else
				help();
			cmd = iw.getString("> ");
		}
	}
	private static void help()
	{
		Console.WriteLine("legal commands are:");
		Console.WriteLine("\tint");
		Console.WriteLine("\tdouble");
		Console.WriteLine("\tdecimal");
		Console.WriteLine("\tstring");
		Console.WriteLine("\tquit");
	}
}
