// Vector.cs

using System;

public struct Vector
{
	public int X1, X2, X3;
	public Vector(int x, int y, int z)
	{
		X1 = x;
		X2 = y;
		X3 = z;
	}
	public static Vector operator+(Vector u, Vector v)
	{
		return new Vector(u.X1 + v.X1, u.X2 + v.X2, u.X3 + v.X3);
	}
	public static Vector operator*(int c, Vector v)
	{
		return new Vector(c * v.X1, c * v.X2, c * v.X3);
	}
	public static int operator*(Vector u, Vector v)
	{
		return u.X1 * v.X1 + u.X2 * v.X2 + u.X3 * v.X3;
	}
	public void Show(string label)
	{
		Console.Write("{0} = ", label);
		Console.WriteLine("({0}, {1}, {2})", X1, X2, X3);
	}
}
