// TestPlayer.cs

using System;

public class TestPlayer
{
	public static void Main()
	{
		Players list = new Players();
		InputWrapper iw = new InputWrapper();
		Console.WriteLine("Enter command, quit to exit");
		string cmd = iw.getString(": ");
		while (! cmd.Equals("quit"))
		{
			if (cmd.Equals("list"))
			{
				list.ShowPlayers();
			}
			else if (cmd.Equals("find"))
			{
				string name = iw.getString("name: ");
				Player play = list.FindPlayer(name);
				if (play == null)
					Console.WriteLine("Player not found");
				else
					Console.WriteLine(play.Show());
			}
			else if (cmd.Equals("login"))
			{
				Player play;
				string name = iw.getString("name: ");
				string pwd = iw.getString("password: ");
				string status = list.Login(name, pwd, out play);
				if (status == "OK")
					Console.WriteLine(play.Show());
				else
					Console.WriteLine(status);
			}
			else if (cmd.Equals("logout"))
			{
				string name = iw.getString("name: ");
				string status = list.Logout(name);
				Console.WriteLine(status);
			}
			else if (cmd.Equals("change"))
			{
				string name = iw.getString("name: ");
				Player play = list.FindPlayer(name);
				if (play == null)
					Console.WriteLine("Player not found");
				else
				{
					decimal bal = iw.getDecimal("new balance: ");
					play.Balance = bal;
				}
			}
			else
				help();
			cmd = iw.getString(": ");
		}
	}

	private static void help()
	{
		Console.WriteLine("The following commands are available:");
		Console.WriteLine("\tlist    -- list players");
		Console.WriteLine("\tfind    -- find a player");
		Console.WriteLine("\tlogin   -- login a player");
		Console.WriteLine("\tlogout  -- logout a player");
		Console.WriteLine("\tchange  -- change balance");
		Console.WriteLine("\tquit    -- exit the program");
	}
}