// ShapeDemo.cs
//
// Demonstrates triangle and square shapes
// Also illustrates testing for string command input
//
// Implements the following commands:
//      show        show current shape
//      size        set shape to a new size
//      move        move shape right (+) or left (-)
//      mark        set mark character
//      triangle    set shape to triangle
//      square      set shape to square
//      quit        exit the program
//
using System;

class ShapeDemo
{
	public static void Main()
	{
		Triangle t = new Triangle(3);
		Square s = new Square(4);
		bool isSquare = true;
		InputWrapper iw = new InputWrapper();
		Console.WriteLine("Shape is square");
		string cmd = iw.getString("> ");
		while (cmd != "quit")
		{
			if (cmd == "show")
			{
				if (isSquare)
					s.Show();
				else
					t.Show();
			}
			else if (cmd == "size")
			{
				int size = iw.getInt("new size: ");
				if (isSquare)
					s.SetSize(size);
				else
					t.SetSize(size);
			}
			else if (cmd == "move")
			{
				int displacement = iw.getInt("displacement: ");
				if (isSquare)
					s.Move(displacement);
				else
					t.Move(displacement);
			}
			else if (cmd == "mark")
			{
				char mark = iw.getChar("new mark: ");
				if (isSquare)
					s.SetMark(mark);
				else
					t.SetMark(mark);
			}
			else if (cmd == "triangle")
			{
				isSquare = false;
			}
			else if (cmd == "square")
			{
				isSquare = true;
			}
			else
				help();
			cmd = iw.getString("> ");
		}
	}
	private static void help()
	{
		Console.WriteLine("legal commands are:");
		Console.WriteLine("\tshow     -- show the shape");
		Console.WriteLine("\tsize     -- change the size");
		Console.WriteLine("\tmove     -- move the shape (+ for right, - for left)");
		Console.WriteLine("\tmark     -- change the mark character ");
		Console.WriteLine("\ttriangle -- set shape to triangle");
		Console.WriteLine("\tsquare   -- set shape to square");
		Console.WriteLine("\tquit     -- exit the program");
	}
}
