// Player.cs

using System;

public class Player
{
	public string Name;	
	private decimal m_balance;
	public bool Active;
	public string m_password;
	public decimal Balance
	{
		get
		{
			return m_balance;
		}
		set
		{
			m_balance = value;
		}
	}
	public Player()
	{
	}
	public Player(string n, string pwd, decimal bal)
	{
		Name = n;
		m_password = pwd;
		m_balance = bal;
		Active = false;
	}
	public Player(string n, string pwd, decimal bal, bool isActive)
	{
		Name = n;
		m_password = pwd;
		m_balance = bal;
		Active = isActive;
	}
	public bool CheckPassword(string pwd)
	{
		if (pwd == m_password)
			return true;
		else
			return false;
	}
	virtual public string Show()
	{
		string strActive = (Active ? "Active" : "Not Active");
		return Name + "\t" + Balance + "\t" + strActive;
	}
	virtual public string Prompt()
	{
		return "> ";
	}
}

public class PlayerList
{
	private const int MAXPLAYER = 4;
	private static int m_next = 0;
	private Player[] m_list = new Player[MAXPLAYER];
	public int Count
	{
		get
		{
			return m_next;
		}
	}

	private int FindIndex(string name)
	{
		for (int i = 0; i < Count; i++)
		{
			Player p = m_list[i];
			if (p.Name == name)
			{
				return i;
			}
		}
		return -1;		// not found
	}

	public string AddPlayer(string name, string pwd, decimal bal)
	{
		if (m_next >= MAXPLAYER)
			return "Too many players";
		else if (FindIndex(name) != -1)
			return "Player " + name + " is already on list";
		else
		{
			Player p = new Player(name, pwd, bal);
			m_list[m_next++] = p;
			return "OK";
		}
	}

	public void Display()
	{
		for (int i = 0; i < Count; i++)
		{
			Player p = m_list[i];
			Console.Write("   ");
			Console.WriteLine(p.Show());
		}
	}
}
