// PlayerDriver.cs

using System;
using System.Collections;

public class PlayerDriver
{
  	private static InputWrapper iw = new InputWrapper(); 
	private static PlayerList players = new PlayerList();
	public static void Main()
	{
		Init();
		Console.WriteLine("Enter command, quit to exit");
		string cmd = iw.getString("player> ");
		while (! cmd.Equals("quit"))
		{
			if (cmd.Equals("add"))
			{
				string name = iw.getString("name: ");
				string pwd = iw.getString("password: ");
				decimal bal = iw.getDecimal("balance: ");
				string status = players.AddPlayer(name, pwd, bal);
				if (status == "OK")
				{
					Console.WriteLine("{0} has been added", name);
				}
				else
					Console.WriteLine(status);
			}
			else if (cmd.Equals("list"))
			{
				Console.WriteLine("Count = {0}", players.Count);
				Display(players);
			}
			else
				help();
			cmd = iw.getString("player> ");
		}
	}

	public static void Init()
	{
		players.AddPlayer("Ann", "aaa", 5000m);
		players.AddPlayer("Bob", "bbb", 5000m);
		players.AddPlayer("Carl", "ccc", 5000m);
	}

	public static void Display(PlayerList players)
	{
		foreach (Player p in players.GetPlayers())
		{
			Console.WriteLine(p.Show());
		}							   
	}

	private static void help()
	{
		Console.WriteLine("The following commands are available:");
		Console.WriteLine("\tadd     -- add a new player");
		Console.WriteLine("\tlist    -- list player information");
		Console.WriteLine("\tquit    -- exit the driver");
	}
}