// Player.cs

using System;

public class Player
{
	public string Name;	
	private decimal m_balance;
	public bool Active;
	public string m_password;
	public decimal Balance
	{
		get
		{
			return m_balance;
		}
		set
		{
			m_balance = value;
		}
	}
	public Player()
	{
	}
	public Player(string n, string pwd, decimal bal)
	{
		Name = n;
		m_password = pwd;
		m_balance = bal;
		Active = false;
	}
	public Player(string n, string pwd, decimal bal, bool isActive)
	{
		Name = n;
		m_password = pwd;
		m_balance = bal;
		Active = isActive;
	}
	public bool CheckPassword(string pwd)
	{
		if (pwd == m_password)
			return true;
		else
			return false;
	}
	virtual public string Show()
	{
		string strActive = (Active ? "Active" : "Not Active");
		return Name + "\t" + Balance + "\t" + strActive;
	}
	virtual public string Prompt()
	{
		return "> ";
	}
}

public class PlayerList
{
	private const int MAXPLAYER = 4;
	private static int m_next = 0;
	private Player[] m_list = new Player[MAXPLAYER];
	public int Count
	{
		get
		{
			return m_next;
		}
	}

	private int FindIndex(string name)
	{
		for (int i = 0; i < Count; i++)
		{
			Player p = m_list[i];
			if (p.Name == name)
			{
				return i;
			}
		}
		return -1;		// not found
	}

	public string AddPlayer(string name, string pwd, decimal bal)
	{
		if (m_next >= MAXPLAYER)
			return "Too many players";
		else if (FindIndex(name) != -1)
			return "Player " + name + " is already on list";
		else
		{
			Player p = new Player(name, pwd, bal);
			m_list[m_next++] = p;
			return "OK";
		}
	}

	public Player[] GetPlayers()
	{
		Player[] list = new Player[Count];
		for (int i = 0; i < Count; i++)
			list[i] = m_list[i];
		return list;
	}

	public string DeletePlayer(string name)
	{
		if (Count == 0)
			return "List is empty";
		int index = FindIndex(name);
		if (index == -1)
			return "Player not found";
		// move players to fill in
		for (int i = index; i < Count - 1; i++)
			m_list[i] = m_list[i+1];
		m_next--;
		return "OK";
	}

	public Player FindPlayer(string name)
	{
		int index = FindIndex(name);
		if (index == -1)
			return null;
		else
			return m_list[index];
	}

	public string GetBalance(string name, out decimal bal)
	{
		bal = 0m;
		Player play = FindPlayer(name);
		if (play == null)
			return "Player not found";
		else
		{
			bal = play.Balance;
			return "OK";
		}
	}

	public string SetBalance(string name, decimal bal)
	{
		Player play = FindPlayer(name);
		if (play == null)
			return "Player not found";
		else
		{
			play.Balance = bal;
			return "OK";
		}
	}

	public string ChangeBalance(string name, decimal delta)
	{
		Player play = FindPlayer(name);
		if (play == null)
			return "Player not found";
		else
		{
			play.Balance += delta;
			return "OK";
		}
	}
}
