// PlayerDriver.cs

using System;
using System.Collections;

public class PlayerDriver
{
  	private static InputWrapper iw = new InputWrapper(); 
	private static PlayerList players = new PlayerList();
	public static void Main()
	{
		Init();
		Console.WriteLine("Enter command, quit to exit");
		string cmd = iw.getString("player> ");
		while (! cmd.Equals("quit"))
		{
			if (cmd.Equals("login"))
			{
				string name = iw.getString("name: ");
				string pwd = iw.getString("password: ");
				Player p;
				string status = players.Login(name, pwd, out p);
				if (status == "OK")
				{
					Console.WriteLine("Welcome, {0}", p.Name);
					Console.WriteLine("Your balance is {0}", p.Balance);
				}
				else
					Console.WriteLine(status);
			}
			else if (cmd.Equals("logout"))
			{
				string name = iw.getString("name: ");
				string status = players.Logout(name);
				if (status == "OK")
					Console.WriteLine("{0} has logged out", name);
				else
					Console.WriteLine(status);
			}
			else if (cmd.Equals("add"))
			{
				string name = iw.getString("name: ");
				string pwd = iw.getString("password: ");
				decimal bal = iw.getDecimal("balance: ");
				string status = players.AddPlayer(name, pwd, bal);
				if (status == "OK")
				{
					Console.WriteLine("{0} has been added", name);
				}
				else
					Console.WriteLine(status);
			}
			else if (cmd.Equals("delete"))
			{
				string name = iw.getString("name: ");
				Player play = players.FindPlayer(name);
				if (play == null)
					Console.WriteLine("Player not found");
				else
				{
					string status = players.DeletePlayer(name);
					Console.WriteLine(status);
				}
			}
			else if (cmd.Equals("find"))
			{
				string name = iw.getString("name: ");
				Player play = players.FindPlayer(name);
				if (play == null)
					Console.WriteLine("Player not found");
				else
					Console.WriteLine(play.Show());
			}
			else if (cmd.Equals("list"))
			{
				Console.WriteLine("Count = {0}", players.Count);
				Display(players);
			}
			else if (cmd.Equals("balance"))
			{
				string name = iw.getString("name: ");
				Player play = players.FindPlayer(name);
				if (play == null)
					Console.WriteLine("Player not found");
				else
				{
					Console.WriteLine("balance = {0}", play.Balance);
					decimal bal = iw.getDecimal("new balance: ");
					string status = players.SetBalance(name, bal);
					if (status == "OK")
					{
						decimal newbal;
						status = players.GetBalance(name, out newbal);
						if (status != "OK")
							Console.WriteLine("status");
						else
							Console.WriteLine("new balance = {0}", newbal);
					}
				}
			}
			else if (cmd.Equals("change"))
			{
				string name = iw.getString("name: ");
				Player play = players.FindPlayer(name);
				if (play == null)
					Console.WriteLine("Player not found");
				else
				{
					Console.WriteLine("balance = {0}", play.Balance);
					decimal delta = iw.getDecimal("delta: ");
					string status = players.ChangeBalance(name, delta);
					if (status == "OK")
					{
						decimal newbal;
						status = players.GetBalance(name, out newbal);
						if (status != "OK")
							Console.WriteLine("status");
						else
							Console.WriteLine("new balance = {0}", newbal);
					}
				}
			}
			else
				help();
		cmd = iw.getString("player> ");
		}
	}

	public static void Init()
	{
		players.AddPlayer("Ann", "aaa", 5000m);
		players.AddPlayer("Bob", "bbb", 5000m);
		players.AddPlayer("Carl", "ccc", 5000m);
	}

	public static void Display(PlayerList players)
	{
		foreach (Player p in players.GetPlayers())
		{
			Console.WriteLine(p.Show());
		}							   
	}

	private static void help()
	{
		Console.WriteLine("The following commands are available:");
		Console.WriteLine("\tlogin   -- login a player");
		Console.WriteLine("\tlogout  -- logout a player");
		Console.WriteLine("\tadd     -- add a new player");
		Console.WriteLine("\tdelete  -- delete a player");
		Console.WriteLine("\tlist    -- list player information");
		Console.WriteLine("\tbalance -- assign a new balance");
		Console.WriteLine("\tchange  -- change the balance");
		Console.WriteLine("\tquit    -- exit the driver");
	}
}