// Item.cs

using System;

public class Item
{
	public string Name;
	public int Quantity;
	public Item(string n, int qty)
	{
		Name = n;
		Quantity = qty;
	}
	public string Show()
	{
		return Name + "\t" + Quantity;
	}
}

public class ItemList
{
	protected const int MAXITEM = 4;
	private int m_next = 0;
	protected Item[] m_list = new Item[MAXITEM];
	public int Count
	{
		get
		{
			return m_next;
		}
	}

	private int FindIndex(string name)
	{
		for (int i = 0; i < Count; i++)
		{
			Item itm = m_list[i];
			if (itm.Name == name)
			{
				return i;
			}
		}
		return -1;		// not found
	}

	protected string AddItem(Item itm)
	{
		if (m_next >= MAXITEM)
			return "Too many Items";
		else if (FindIndex(itm.Name) != -1)
			return "Item " + itm.Name + " is already on list";
		else
		{
			m_list[m_next++] = itm;
			return "OK";
		}
	}

	public string AddItem(string name, int qty)
	{
		if (m_next >= MAXITEM)
			return "Too many Items";
		else if (FindIndex(name) != -1)
			return "Item " + name + " is already on list";
		else
		{
			Item itm = new Item(name, qty);
			m_list[m_next++] = itm;
			return "OK";
		}
	}

	public string DeleteItem(string name)
	{
		if (Count == 0)
			return "List is empty";
		int index = FindIndex(name);
		if (index == -1)
			return "Item not found";
		// move items to fill in
		for (int i = index; i < Count - 1; i++)
			m_list[i] = m_list[i+1];
		m_next--;
		return "OK";
	}

	public Item FindItem(string name)
	{
		int index = FindIndex(name);
		if (index == -1)
			return null;
		else
			return m_list[index];
	}

	public string ChangeQuantity(string name, int delta)
	{
		Item itm = FindItem(name);
		if (itm == null)
			return "Not found";
		else
		{
			itm.Quantity += delta;
			return "OK";
		}
	}

	public Item[] GetItems()
	{
		Item[] list = new Item[Count];
		for (int i = 0; i < Count; i++)
			list[i] = m_list[i];
		return list;
	}
}