// ItemDriver.cs

using System;

public class ItemDriver
{
	private static ItemList items = new ItemList();
  	private static InputWrapper iw = new InputWrapper(); 
	public static void Loop()
	{
		Init();
		Console.WriteLine("Enter command, quit to exit");
		string cmd = iw.getString("item> ");
		while (! cmd.Equals("quit"))
		{
			if (cmd.Equals("list"))
			{
				Console.WriteLine("Count = {0}", items.Count);
				Display(items);
			}
			else if (cmd.Equals("add"))
			{
				string name = iw.getString("name: ");
				int qty = iw.getInt("quantity: ");
				string status = items.AddItem(name, qty);
				Console.WriteLine(status);
			}
			else if (cmd.Equals("delete"))
			{
				string name = iw.getString("name: ");
				string status = items.DeleteItem(name);
				Console.WriteLine(status);
			}
			else if (cmd.Equals("find"))
			{
				string name = iw.getString("name: ");
				Item itm = items.FindItem(name);
				if (itm == null)
					Console.WriteLine("Item not found");
				else
					Console.WriteLine(itm.Show());
			}
			else if (cmd.Equals("change"))
			{
				string name = iw.getString("name: ");
				int delta = iw.getInt("delta: ");
				string status = items.ChangeQuantity(name, delta);
				Item itm = items.FindItem(name);
				Console.WriteLine(status);
			}
			else
				help();
			cmd = iw.getString("item> ");
		}
	}

	private static void Init()
	{
		items.AddItem("axe", 100);
		items.AddItem("ball", 50);
		items.AddItem("cart", 120);
	}

	public static void Display(ItemList items)
	{
		foreach (Item itm in items.GetItems())
		{
			Console.WriteLine(itm.Show());
		}							   
	}

	private static void help()
	{
		Console.WriteLine("The following commands are available:");
		Console.WriteLine("\tlist    -- list items");
		Console.WriteLine("\tadd     -- add an item");
		Console.WriteLine("\tdelete  -- delete an item");
		Console.WriteLine("\tfind    -- find an item");
		Console.WriteLine("\tchange  -- change quantity");
		Console.WriteLine("\tquit    -- exit the driver");
	}
}