// ProductDriver.cs

using System;

public class ProductDriver
{
	//private static ProductList prods = new ProductList("Some Vendor");
  	private static InputWrapper iw = new InputWrapper(); 
	public static void Loop()
	{
		Console.WriteLine("Enter command, quit to exit");
		string cmd = iw.getString("product> ");
		while (! cmd.Equals("quit"))
		{
			if (cmd.Equals("list"))
			{
				Display(Game.prods);
			}
			else if (cmd.Equals("add"))
			{
				string name = iw.getString("name: ");
				int qty = iw.getInt("quantity: ");
				decimal price = iw.getDecimal("price: ");
				string status = Game.prods.AddProduct(name, qty, price);
				Console.WriteLine(status);
			}
			else if (cmd.Equals("delete"))
			{
				string name = iw.getString("name: ");
				string status = Game.prods.DeleteItem(name);
				Console.WriteLine(status);
			}
			else if (cmd.Equals("find"))
			{
				string name = iw.getString("name: ");
				Product itm = Game.prods.FindProduct(name);
				if (itm == null)
					Console.WriteLine("Product not found");
				else
					Console.WriteLine(itm.Show());
			}
			else if (cmd.Equals("changeq"))
			{
				string name = iw.getString("name: ");
				int delta = iw.getInt("delta: ");
				string status = Game.prods.ChangeQuantity(name, delta);
				Console.WriteLine(status);
			}
			else if (cmd.Equals("changep"))
			{
				string name = iw.getString("name: ");
				decimal delta = iw.getDecimal("delta: ");
				string status = Game.prods.ChangePrice(name, delta);
				Console.WriteLine(status);
			}
			else
				help();
			cmd = iw.getString("product> ");
		}
	}

	public static void Display(ProductList prods)
	{
		Console.WriteLine("Vendor name = {0}", prods.VendorName);
		Console.WriteLine("Count = {0}", prods.Count);
		foreach (Product prod in prods.GetProducts())
		{
			Console.WriteLine(prod.Show());
		}							   
	}

	private static void help()
	{
		Console.WriteLine("The following commands are available:");
		Console.WriteLine("\tlist    -- list products");
		Console.WriteLine("\tadd     -- add a product");
		Console.WriteLine("\tdelete  -- delete a product");
		Console.WriteLine("\tfind    -- find a product");
		Console.WriteLine("\tchangeq -- change quantity");
		Console.WriteLine("\tchangep -- change price");
		Console.WriteLine("\tquit    -- exit the driver");
	}
}