// TestShape.cs

using System;

public class TestShape
{
	private static ShapeList list = new ShapeList();
	public static void Main()
	{
		InputWrapper iw = new InputWrapper();
		Init();
		string cmd = iw.getString("> ");
		while (! cmd.Equals("quit"))
		{
			if (cmd.Equals("display"))
			{
				list.DisplayShapes();
			}
			else if (cmd.Equals("add"))
			{
				Shape shp = null;
				ShapeType st = (ShapeType) 
					iw.getInt("shape type (1 = Square, 2 = Rectangle): ");
				if (st == ShapeType.Square)
				{
					int size = iw.getInt("size: ");
					shp = new Square(size);
				}
				else if (st == ShapeType.Rectangle)
				{
					int bas = iw.getInt("base: ");
					int height = iw.getInt("height: ");
					shp = new Rectangle(bas, height);
				}
				if (shp == null)
					Console.WriteLine("Illegal shape type");
				else
				{
					string status = list.AddShape(shp);
					Console.WriteLine(status);
				}
			}
			else
				help();
			cmd = iw.getString("> ");
		}
	}

	private static void Init()
	{
		list.AddShape(new Square(3));
		list.AddShape(new Rectangle(5, 2));
		list.AddShape(new Square(6));
	}

	private static void help()
	{
		Console.WriteLine("The following commands are available:");
		Console.WriteLine("\tdisplay -- display shapes");
		Console.WriteLine("\tadd     -- add a shape");
		Console.WriteLine("\tquit    -- exit the driver");
	}
}
