// ShapeList.cs

using System;

public class ShapeList
{
	protected const int MAXSHAPE = 10;
	private int m_next = 0;
	protected Shape[] m_list = new Shape[MAXSHAPE];
	public int Count
	{
		get
		{
			return m_next;
		}
	}

	public string AddShape(Shape shp)
	{
		if (m_next >= MAXSHAPE)
			return "Too many shapes";
		else
		{
			m_list[m_next++] = shp;
			return "OK";
		}
	}

	public void DisplayShapes()
	{
		for (int i = 0; i < Count; i++)
		{
			Console.Write("{0}\t", i);
			m_list[i].Display();
		}
	}

	public Shape GetShape(int index)
	{
		if (index < 0 || index >= Count)
			return null;
		else
			return m_list[index];
	}

	public string ChangeSize(int index, Shape shp)
	{
		if (index < 0 || index >= Count)
			return "Index out of range";
		if (shp.GetType() != m_list[index].GetType())
			return "Improper shape type";
		m_list[index] = shp;
		return "OK";
	}
}

