// Game.cs

public class Game
{
	public static PlayerList players = new PlayerList();
	public static Wholesaler whole = new Wholesaler();
	public static Vendor CurrentVendor = null;
	public static ProductList prods
	{
		get
		{
			return whole.Products;
		}
	}
	static Game()
	{
		prods.AddProduct("airplane toy", 10000, 10m);
		prods.AddProduct("beanie baby", 10000, 15m);
		prods.AddProduct("cat carrier", 10000, 25m);
		prods.AddProduct("dog bone", 10000, 5m);
		prods.AddProduct("elephant gun", 10000, 55m);
		prods.AddProduct("fruit basket", 10000, 10m);

		players.AddPlayer(new Shopper("Ann", "aaa", 5000m));
		players.AddPlayer(new Shopper("Bob", "bbb", 5000m));
		players.AddPlayer(new Shopper("Carl", "ccc", 5000m));

		Vendor v = new Vendor("Toyland", "ttt", 15000m, "toyland.com");
		v.Products.AddProduct("airplane toy", 500, 15m);
		v.Products.AddProduct("beanie baby", 500, 25m);
		v.Products.AddProduct("dog bone", 500, 10m);
		players.AddPlayer(v);

		v = new Vendor("Petworld", "ppp", 15000m, "petworld.com");
		v.Products.AddProduct("cat carrier", 500, 35m);
		v.Products.AddProduct("dog bone", 500, 15m);
		players.AddPlayer(v);

		v = new Vendor("Foodstore", "fff", 15000m, "foodstore.com");
		v.Products.AddProduct("dog bone", 500, 10m);
		v.Products.AddProduct("fruit basket", 500, 15m);
		players.AddPlayer(v);
	}

	public static string VendorBuy(string prodName, int qty)
	{
		decimal price;
		string status = whole.Sell(prodName, qty, out price);
		if (status != "OK")
			return status;
		else
		{
			status = players.ChangeBalance(CurrentVendor.Name, -qty*price);
			if (status == "OK")
			{
				ProductList list = CurrentVendor.Products;
				status = list.ChangeQuantity(prodName, qty);
			}
			return status;
		}
	}
}