// Vendor.cs

public class Vendor : Player
{
	private ProductList m_prods;
	public string Url;
	public Vendor(string name, string pwd, decimal bal, string vUrl) : 
		base(name, pwd, bal)
	{
		Url = vUrl;
		m_prods = new ProductList(name);
	}
	override public string Prompt()
	{
		return "V> ";
	}
	override public string Show()
	{
		return base.Show() + "   " + Url;
	}
	public ProductList Products
	{
		get
		{
			return m_prods;
		}
	}
	public Product[] GetProducts()
	{
		return m_prods.GetProducts();
	}
	public string Sell(string prodName, int qty, out decimal price)
	{
		price = 0m;
		Product prod = m_prods.FindProduct(prodName);
		if (prod == null)
			return "Product not found";
		if (prod.Quantity < qty)
			return "Insufficient quantity";
		string status = m_prods.ChangeQuantity(prodName, -qty);
		if (status != "OK")
			return status;
		Game.players.ChangeBalance(Name, qty * prod.Price);
		price = prod.Price;
		return "OK";
	}
}
