// Defs.cs

using System.Collections;

public interface IProducts
{
	int Count {get;}
	string AddProduct(string name, int qty, decimal price);
	string DeleteProduct(string name);
	Product FindProduct(string name);
	string ChangeQuantity(string name, int delta);
	string ChangePrice(string name, decimal delta);
}

public interface IProductList : IProducts
{
	IList GetProducts();
}

interface IItems
{
	int Count {get;}
	string AddItem(string name, int qty);
	string DeleteItem(string name);
	Item FindItem(string name);
	string ChangeQuantity(string name, int delta);
}

interface IItemList : IItems
{
	IList GetItems();
}

public interface IVendorName
{
	string VendorName {get; set;}
}

public interface IPlayerAdmin
{
	int Count {get;}
	string AddPlayer(string name, string pwd, decimal bal, int roleId);
	Player FindPlayer(string name);
	string DeletePlayer(string name);
	IList GetPlayers();
}

public interface IVendorAdmin
{
	string FindUrl(string name);
	string AddUrl(string name, string url);
	string DeleteUrl(string name);
}

interface IVendorInfo
{
	Vendor FindVendor(string url);
}

public interface IPlayer
{
	string Login(string name, string pwd, out Player play);
	string Logout(string name);
	string ChangeBalance(string name, decimal delta);
	string GetBalance(string name, out decimal bal);
	string SetBalance(string name, decimal bal);
}
