// ShopperDriver.cs

using System;
using System.Collections;

public class ShopperDriver
{
	private static InputWrapper iw = new InputWrapper(); 
	public static void Loop()
	{
		Console.WriteLine("Your shopping list:");
		ShowItemList(Game.CurrentShopper.GetShoppingList());
		Console.WriteLine("Enter command, logout when done");
		string cmd = iw.getString(Game.CurrentShopper.Prompt());
		while (true)
		{
			try
			{
				if (cmd.Equals("visit"))
				{
					string url = iw.getString("url: ");
					Game.CurrentVendor = Game.FindVendor(url);
					if (Game.CurrentVendor == null)
						Console.WriteLine("Vendor not found");
					else
						Console.WriteLine("Welcome to {0}", Game.CurrentVendor.Name);
				}
				else if (cmd.Equals("logout"))
				{
					string name = Game.CurrentShopper.Name;
					string status = Game.iplay.Logout(name);
					if (status == "OK")
					{
						Game.CurrentShopper = null;
						Console.WriteLine("{0} has logged out", name);
						return;
					}
					else
						Console.WriteLine(status);
				}
				else if (cmd.Equals("buy"))
				{
					if (Game.CurrentVendor == null)
						Console.WriteLine("Please visit a vendor");
					else
					{
						string prodName = iw.getString("product name: ");
						int qty = iw.getInt("quantity: ");
						string status = Game.ShopperBuy(prodName, qty);
						Console.WriteLine(status);
					}
				}
				else if (cmd.Equals("list"))
				{
					if (Game.CurrentVendor != null)
						ShowList(Game.CurrentVendor.GetProducts());
					else
						Console.WriteLine("Please visit a vendor");
				}
				else if (cmd.Equals("mylist"))
				{
					if (Game.CurrentShopper != null)
					{
						string name = Game.CurrentShopper.Name;
						decimal bal;
						string status = Game.iplay.GetBalance(name, out bal);
						if (status == "OK")
						{
							Console.WriteLine("Balance = {0:C}", bal);
							ShowItemList(Game.CurrentShopper.GetShoppingList());
						}
						else
							Console.WriteLine(status);
					}
					else
						Console.WriteLine("There is no current shopperr");
				}
				else
					help();
			}
			catch (Exception e)
			{
				Console.WriteLine("Exception: {0}", e.Message);
			}
			cmd = iw.getString(Game.CurrentShopper.Prompt());
		}
	}

	private static void ShowList(IList list)
	{
		foreach (Product prod in list)
			Console.WriteLine(prod.Show());
	}

	private static void ShowItemList(IList list)
	{
		foreach (Item itm in list)
		{
			Console.Write("   ");
			Console.WriteLine(itm.Show());
		}
	}

	private static void help()
	{
		Console.WriteLine("The following commands are available:");
		Console.WriteLine("\tvisit   -- visit a vendor");
		Console.WriteLine("\tlogout  -- logout a player");
		Console.WriteLine("\tbuy     -- buy from current vendor");
		Console.WriteLine("\tlist    -- list products of current vendor");
		Console.WriteLine("\tmylist  -- show my shopping list");
	}
}