// Game.cs

public class Game
{
	public static PlayerList players = new PlayerList();
	public static Wholesaler whole = new Wholesaler();
	public static Vendor CurrentVendor = null;
	public static Shopper CurrentShopper = null;
	public static IPlayer iplay;
	public static IPlayerAdmin iplayadm;
	public static IVendorAdmin ivendadm;
	public static IProductList iprods;
	public static IVendorName ivendname;
	public static VendorData vendata = new VendorData();
	public static void InitGame()
	{
		SetInterfaces();
		iprods.AddProduct("airplane toy", 10000, 10m);
		iprods.AddProduct("beanie baby", 10000, 15m);
		iprods.AddProduct("cat carrier", 10000, 25m);
		iprods.AddProduct("dog bone", 10000, 5m);
		iprods.AddProduct("elephant gun", 10000, 50m);
		iprods.AddProduct("fruit basket", 10000, 10m);

		iplayadm.AddPlayer("Ann", "aaa", 5000m, (int) PlayerRole.Shopper);
		iplayadm.AddPlayer("Bob", "bbb", 5000m, (int) PlayerRole.Shopper);
		iplayadm.AddPlayer("Carl", "ccc", 5000m, (int) PlayerRole.Shopper);

		iplayadm.AddPlayer("Toyland", "ttt", 15000m, (int) PlayerRole.Vendor);
		Vendor v = (Vendor) iplayadm.FindPlayer("Toyland");
		v.Products.AddProduct("airplane toy", 500, 15m);
		v.Products.AddProduct("beanie baby", 500, 25m);
		v.Products.AddProduct("elephant gun", 500, 55m);
		ivendadm.AddUrl("Toyland", "toyland.com");

		iplayadm.AddPlayer("Petworld", "ppp", 15000m, (int) PlayerRole.Vendor);
		v = (Vendor) iplayadm.FindPlayer("Petworld");
		v.Products.AddProduct("cat carrier", 500, 35m);
		v.Products.AddProduct("dog bone", 500, 15m);
		ivendadm.AddUrl("Petworld", "petworld.com");

		iplayadm.AddPlayer("Foodstore", "fff", 15000m, (int) PlayerRole.Vendor);
		v = (Vendor) iplayadm.FindPlayer("Foodstore");
		v.Products.AddProduct("dog bone", 500, 10m);
		v.Products.AddProduct("fruit basket", 500, 15m);
		ivendadm.AddUrl("Foodstore", "foodstore.com");
	}

	private static void SetInterfaces()
	{
		iplay = players;
		iplayadm = players;
		ivendadm = players;
		iprods = whole.Products;
		ivendname = whole.VendorName;
	}

	public static string VendorBuy(string prodName, int qty)
	{
		decimal price;
		string status = whole.Sell(prodName, qty, out price);
		if (status != "OK")
			return status;
		else
		{
			status = players.ChangeBalance(CurrentVendor.Name, -qty*price);
			if (status == "OK")
			{
				IProductList iprods = CurrentVendor.Products;
				status = iprods.ChangeQuantity(prodName, qty);
			}
			return status;
		}
	}

	public static string ShopperBuy(string prodName, int qty)
	{
		decimal price;
		string status = CurrentVendor.Sell(prodName, qty, out price);
		if (status != "OK")
			return status;
		else
		{
			status = players.ChangeBalance(CurrentShopper.Name, -qty*price);
			if (status == "OK")
			{
				IItemList ilist = CurrentShopper.Items;
				status = ilist.ChangeQuantity(prodName, -qty);
				if (status != "OK")
					return status;
				else
					return "OK";
			}
			else
				return status;
		}
	}
}

public class VendorData : IVendorInfo
{
	public Vendor FindVendor(string url)
	{
		foreach (Player play in Game.iplayadm.GetPlayers())
		{
			if (play.GetType() == typeof(Vendor))
			{
				Vendor v = (Vendor) play;
				if (v.Url == url)
					return v;
			}
		}
		return null;
	}
}