// Player.cs

using System;
using System.Collections;

public class Player
{
	public string Name;	
	public decimal Balance;
	public Player(string n,  decimal bal)
	{
		Name = n;
		Balance = bal;
	}
	override public string ToString()
	{
		return string.Format("{0,-10}  {1:C}", Name, Balance);
	}
}

public class PlayerList 
{
	private Hashtable m_list = new Hashtable();
	public int Count
	{
		get
		{
			return m_list.Count;
		}
	}

	public Player FindPlayer(string name)
	{
		return (Player) m_list[name];
	}

	public string AddPlayer(string name, decimal bal)
	{
		try
		{
			Player play = new Player(name, bal);
			m_list.Add(name, play);
		}
		catch (ArgumentException)
		{
			return "Player already in list";
		}
		catch (Exception e)
		{
			return e.Message;
		}
		return "OK";
	}

	public string DeletePlayer(string name)
	{
		if (m_list.Contains(name))
		{
			m_list.Remove(name);
			return "OK";
		}
		else
			return "Player not found";
	}

	public IList GetPlayers()
	{
		ArrayList list = new ArrayList();
		IDictionaryEnumerator iter = m_list.GetEnumerator();
		while (iter.MoveNext())
		{
			list.Add(iter.Value);
		}
		return list;
	}
}
