// Driver.cs

using System;
using System.Collections;

public class HistoryDriver
{
	public static void Main()
	{
		InputWrapper iw = new InputWrapper();
		History hist = new History();
		ArrayList list = new ArrayList();
		HistoryDelegate annDelg = new HistoryDelegate(hist.Announce);
		HistoryDelegate recDelg = new HistoryDelegate(hist.Record);
		HistoryDelegate curDelg = null;
		bool announce = false;
		bool record = false;
		Console.WriteLine("Enter command, quit to exit");
		string cmd = iw.getString(": ");
		while (! cmd.Equals("quit"))
		{
			try
			{
				if (cmd.Equals("add"))
				{
					string name = iw.getString("name: ");
					if (! list.Contains(name))
					{
						list.Add(name);
						if (curDelg != null)
							curDelg(name, "added");
					}
					else
						Console.WriteLine("{0} is already on the list", name);
				}
				else if (cmd.Equals("delete"))
				{
					string name = iw.getString("name: ");
					if (list.Contains(name))
					{
						list.Remove(name);
						if (curDelg != null)
							curDelg(name, "deleted");
					}
					else
						Console.WriteLine("{0} is not on the list", name);
				}
				else if (cmd.Equals("list"))
				{
					foreach (string str in list)
						Console.WriteLine(str);
				}
				else if (cmd.Equals("announce"))
				{
					if (announce)
					{
						curDelg -= annDelg;
						Console.WriteLine("announce is OFF");
					}
					else
					{
						curDelg += annDelg;
						Console.WriteLine("announce is ON");
					}
					announce = ! announce;
				}				
				else if (cmd.Equals("record"))
				{
					if (record)
					{
						curDelg -= recDelg;
						Console.WriteLine("record is OFF");
					}
					else
					{
						curDelg += recDelg;
						Console.WriteLine("record is ON");
					}
					record = ! record;
				}
				else if (cmd.Equals("history"))
					hist.Display();
				else
					help();
			}
			catch (Exception e)
			{
				Console.WriteLine("Exception: {0}", e.Message);
			}
			cmd = iw.getString(": ");
		}
	}
	private static void help()
	{
		Console.WriteLine("The following commands are available:");
		Console.WriteLine("\tadd       -- add a name");
		Console.WriteLine("\tdelete    -- delete a name");
		Console.WriteLine("\tlist      -- list all names");
		Console.WriteLine("\tannounce  -- toggle announce");
		Console.WriteLine("\trecord    -- toggle record");
		Console.WriteLine("\thistory   -- display the history list");
		Console.WriteLine("\tquit      -- exit the program");
	}
}