// History.cs

using System;
using System.Collections;

public class HistoryEventArgs : EventArgs
{
	public string Name;
	public string Action;
	public HistoryEventArgs(string name, string action)
	{
		Name = name;
		Action = action;
	}
}

public class History
{
	private ArrayList m_history = new ArrayList();
	public void Announce(object sender, HistoryEventArgs ev)
	{
		Console.WriteLine(ev.Name + " " + ev.Action);
	}
	public void Record(object sender, HistoryEventArgs ev)
	{
		m_history.Add(ev.Name + " " + ev.Action);
	}
	public void Display()
	{
		foreach (string str in m_history)
			Console.WriteLine(str);
	}
}
