// GameDriver.cs

using System;

public class GameDriver
{
  	private static InputWrapper iw = new InputWrapper(); 
	public static void Main()
	{
		try
		{
			Game.InitGame();
		}
		catch (Exception e)
		{
			Console.WriteLine(e.Message);
			return;
		}
		Console.WriteLine("Enter command, quit to exit");
		string cmd = iw.getString(": ");
		while (! cmd.Equals("quit"))
		{
			try
			{
				if (cmd.Equals("player"))
				{
					PlayerDriver.Loop();
				}
				else if (cmd.Equals("product"))
				{
					ProductDriver.Loop();
				}
				else if (cmd.Equals("vendor"))
				{
					Console.WriteLine("Please login");
					string name = iw.getString("name: ");
					string pwd = iw.getString("password: ");
					Player p;
					string status = Game.players.Login(name, pwd, out p);
					if (status == "OK")
					{
						if (p.GetType() == typeof(Vendor))
						{
							Game.CurrentVendor = (Vendor) p;
							Console.WriteLine("Welcome, {0}", p.Name);
							Console.WriteLine("Your balance is {0:C}", p.Balance);
							VendorDriver.Loop();
						}
						else
						{
							Console.WriteLine("Not a vendor");
							string result = Game.players.Logout(name);
							if (result == "OK")
								Console.WriteLine("Logged out");
							else
								Console.WriteLine(result);
						}
					}
					else
						Console.WriteLine(status);
				}
				else if (cmd.Equals("shopper"))
				{
					Console.WriteLine("Please login");
					string name = iw.getString("name: ");
					string pwd = iw.getString("password: ");
					Player p;
					string status = Game.players.Login(name, pwd, out p);
					if (status == "OK")
					{
						if (p.GetType() == typeof(Shopper))
						{
							if (status == "OK")
							{
								Game.CurrentShopper = (Shopper) p;
								Console.WriteLine("Welcome, {0}", p.Name);
								Console.WriteLine("Your balance is {0:C}", p.Balance);
								ShopperDriver.Loop();
							}
							else
								Console.WriteLine(status);
						}
						else
						{
							Console.WriteLine("Not a shopper");
							string result = Game.players.Logout(name);
							if (result == "OK")
								Console.WriteLine("Logged out");
							else
								Console.WriteLine(result);
						}
					}
					else
						Console.WriteLine(status);
				}
				else
					help();
			}
			catch (Exception e)
			{
				Console.WriteLine("Exception: {0}", e.Message);
			}
			cmd = iw.getString(": ");
		}
	}
	private static void help()
	{
		Console.WriteLine("The following commands are available:");
		Console.WriteLine("\tplayer  -- player driver");
		Console.WriteLine("\tproduct -- product driver");
		Console.WriteLine("\tvendor  -- vendor driver");
		Console.WriteLine("\tshopper -- shopper driver");
		Console.WriteLine("\tquit    -- exit the program");
	}
}