// Product.cs

using System;
using System.Collections;

public class Product : Item
{
	public decimal Price;
	public Product(string n, int qty, decimal p) : base(n, qty)
	{
		Price = p;
	}
	override public string ToString()
	{
		return base.ToString() + "   " + string.Format("{0,10:C}", Price);
	}
}

public class ProductList : ItemList, IProductList, IVendorName
{
	private string m_VendorName;
	public string VendorName
	{
		get
		{
			return m_VendorName;
		}
		set
		{
			m_VendorName = value;
		}
	}
	public ProductList(string name)
	{
		VendorName = name;
	}
	public string AddProduct(string name, int qty, decimal price)
	{
		if (price <= 0m)
			return "Price must be positive";
		else
		{
			Product p = new Product(name, qty, price);
			return base.AddItem(p);
		}
	}

	public Product FindProduct(string name)
	{
		return (Product) base.FindItem(name);
	}

	public string DeleteProduct(string name)
	{
		return base.DeleteItem(name);
	}

	new public string ChangeQuantity(string name, int delta)
	{
		return base.ChangeQuantity(name, delta);
	}

	public string ChangePrice(string name, decimal delta)
	{
		Product prod = FindProduct(name);
		if (prod == null)
			return "Not found";
		else
		{
			prod.Price += delta;
			return "OK";
		}
	}

	public IList GetProducts()
	{
		return m_list;
	}
}

