// Driver.cs

using System;
using System.Threading;

public class ThreadDriver
{
	public static void Main()
	{
		InputWrapper iw = new InputWrapper();
		Console.WriteLine("Enter command, quit to exit");
		string cmd = iw.getString("thread> ");
		while (! cmd.Equals("quit"))
		{
			try
			{
				if (cmd.Equals("new"))
				{
					int delta = iw.getInt("delta: ");
					int count = iw.getInt("count: ");
					string name = iw.getString("name: ");
					ConsoleLog log = new ConsoleLog(delta, count, name);
					ThreadStart start = new ThreadStart(log.ConsoleThread);
					Thread t = new Thread(start);
					t.Start();
				}
				else
					help();
			}
			catch (Exception e)
			{
				Console.WriteLine("Exception: {0}", e.Message);
			}
			cmd = iw.getString("thread> ");
		}
	}
	private static void help()
	{
		Console.WriteLine("The following commands are available:");
		Console.WriteLine("\tnew       -- start a new thread");
		Console.WriteLine("\tquit      -- exit the program");
	}
}