// Driver.cs

using System;
using System.Threading;
using System.Collections;

public class ThreadDriver
{
	public static void Main()
	{
		ThreadList list = new ThreadList();
		InputWrapper iw = new InputWrapper();
		Console.WriteLine("Enter command, quit to exit");
		string cmd = iw.getString("thread> ");
		while (! cmd.Equals("quit"))
		{
			try
			{
				if (cmd.Equals("new"))
				{
					int delta = iw.getInt("delta: ");
					int count = iw.getInt("count: ");
					string name = iw.getString("name: ");
					ConsoleLog log = new ConsoleLog(delta, count, name);
					ThreadStart start = new ThreadStart(log.ConsoleThread);
					Thread t = new Thread(start);
					t.Name = name;
					list.Add(t, delta);
					//t.Start();
				}
				else if (cmd.Equals("list"))
					ShowThreads(list.GetThreads());
				else if (cmd.Equals("start"))
					StartThreads(list.GetThreads());
				else
					help();
			}
			catch (Exception e)
			{
				Console.WriteLine("Exception: {0}", e.Message);
			}
			cmd = iw.getString("thread> ");
		}
	}

	private static void ShowThreads(IList list)
	{
		foreach (ThreadInfo ti in list)
			Console.WriteLine(ti);
	}

	private static void StartThreads(IList list)
	{
		foreach (ThreadInfo ti in list)
			ti.t.Start();
	}

	private static void help()
	{
		Console.WriteLine("The following commands are available:");
		Console.WriteLine("\tnew       -- create a new thread");
		Console.WriteLine("\tlist      -- list all threads");
		Console.WriteLine("\tstart     -- start all threads");
		Console.WriteLine("\tquit      -- exit the program");
	}
}