// Player.cs

using System;
using System.Collections;


public class Player
{
	public string Name;	
	private decimal m_balance;
	public decimal Balance
	{
		get
		{
			return m_balance;
		}
		set
		{
			m_balance = value;
		}
	}
	public Player(string n,  decimal bal)
	{
		Name = n;
		m_balance = bal;
	}
	override public string ToString()
	{
		return string.Format("{0, -10}  {1, 10:C}", Name, Balance);
	}
}

public class PlayerList 
{
	private ArrayList m_list = new ArrayList();
	public int Count
	{
		get
		{
			return m_list.Count;
		}
	}

	public Player FindPlayer(string name)
	{
		foreach (Player play in m_list)
		{
			if (play.Name == name)
				return play;
		}
		return null;
	}

	public string AddPlayer(string name, decimal bal)
	{
		if (FindPlayer(name) != null)
			return "Player already on list";
		Player play = new Player(name, bal);
		m_list.Add(play);
		return "OK";
	}

	public IList GetPlayers()
	{
		return m_list;
	}

	public void Clear()
	{
		m_list.Clear();
	}
}
