// PlayerDriver.cs

using System;
using System.IO;
using System.Runtime.Serialization.Formatters.Soap;

public class PlayerDriver
{
	private static PlayerList players = new PlayerList();
  	private static InputWrapper iw = new InputWrapper(); 
	public static void Main()
	{
		Console.WriteLine("Enter command, quit to exit");
		string cmd = iw.getString("player> ");
		while (! cmd.Equals("quit"))
		{
			try
			{
				if (cmd.Equals("add"))
				{
					string name = iw.getString("name: ");
					decimal bal = iw.getDecimal("balance: ");
					string status = players.AddPlayer(name, bal);
					Console.WriteLine(status);
				}
				else if (cmd.Equals("find"))
				{
					string name = iw.getString("name: ");
					Player play = players.FindPlayer(name);
					if (play == null)
						Console.WriteLine("Player not found");
					else
						Console.WriteLine(play.ToString());
				}
				else if (cmd.Equals("list"))
				{
					Console.WriteLine("Count = {0}", players.Count);
					DisplayPlayers();
				}
				else if (cmd.Equals("clear"))
				{
					players.Clear();
				}
				else if (cmd.Equals("save"))
				{
					FileInfo f = new FileInfo("players.txt");
					Stream s = f.Open(FileMode.Create);
					SoapFormatter soap = new SoapFormatter();
					soap.Serialize(s, players);
					s.Close();
				}
				else if (cmd.Equals("load"))
				{
					FileInfo f = new FileInfo("players.txt");
					Stream s = f.Open(FileMode.Open);
					SoapFormatter soap = new SoapFormatter();
					players = (PlayerList) soap.Deserialize(s);
					s.Close();
				}
				else
					help();
			}
			catch (Exception e)
			{
				Console.WriteLine("Exception: {0}", e.Message);
			}
			cmd = iw.getString("player> ");
		}
	}

	public static void DisplayPlayers()
	{
		foreach (Player p in players.GetPlayers())
		{
			Console.WriteLine(p);
		}							   
	}

	private static void help()
	{
		Console.WriteLine("The following commands are available:");
		Console.WriteLine("\tadd     -- add a new player");
		Console.WriteLine("\tfind    -- find a player");
		Console.WriteLine("\tlist    -- list player information");
		Console.WriteLine("\tclear   -- clear players");
		Console.WriteLine("\tsave    -- save player information");
		Console.WriteLine("\tload    -- load player information");
		Console.WriteLine("\tquit    -- exit the driver");
	}
}