// PlayerDriver.cs

using System;

public class PlayerDriver
{
  	private static InputWrapper iw = new InputWrapper(); 
	public static void Main()
	{
		Console.WriteLine("Enter command, quit to exit");
		string cmd = iw.getString("> ");
		while (! cmd.Equals("quit"))
		{
			try
			{
				if (cmd.Equals("add"))
				{
					double x = iw.getDouble("first double: ");
					double y = iw.getDouble("second double: ");
					Show(SimpleMath.Add(x, y));
				}
				else if (cmd.Equals("subtract"))
				{
					double x = iw.getDouble("first double: ");
					double y = iw.getDouble("second double: ");
					Show(SimpleMath.Subtract(x, y));
				}
				else if (cmd.Equals("multiply"))
				{
					double x = iw.getDouble("first double: ");
					double y = iw.getDouble("second double: ");
					Show(SimpleMath.Multiply(x, y));
				}
				else if (cmd.Equals("divide"))
				{
					double x = iw.getDouble("first double: ");
					double y = iw.getDouble("second double: ");
					Show(SimpleMath.Divide(x, y));
				}
				else
					help();
			}
			catch (Exception e)
			{
				Console.WriteLine("Exception: {0}", e.Message);
			}
			cmd = iw.getString("> ");
		}
	}

	private static void Show(double x)
	{
		Console.WriteLine("{0:F4}", x);
	}

	private static void help()
	{
		Console.WriteLine("The following commands are available:");
		Console.WriteLine("\tadd      -- add two doubles");
		Console.WriteLine("\tsubtract -- subtract two doubles");
		Console.WriteLine("\tmultiply -- multiply two doubles");
		Console.WriteLine("\tdivide   -- divide two doubles");
		Console.WriteLine("\tquit     -- exit the driver");
	}
}