// Defs.cs

using System;
using System.Collections;

public interface IPlayerAdmin
{
	int Count {get;}
	string AddPlayer(string name, string pwd, decimal bal, int roleId);
	Player FindPlayer(string name);
	string DeletePlayer(string name);
	IList GetPlayers();
}

public interface IPlayer
{
	string Login(string name, string pwd, out Player play);
	string Logout(string name);
	string ChangeBalance(string name, decimal delta);
	string GetBalance(string name, out decimal bal);
	string SetBalance(string name, decimal bal);
}

public delegate void PlayerEventHandler(object sender, PlayerEventArgs ev);

public class PlayerEventArgs : EventArgs
{
	public string Name;
	public decimal Balance;
	public PlayerEventArgs(string name, decimal bal)
	{
		Name = name;
		Balance = bal;
	}
}

public interface IPlayerEvents
{
	event PlayerEventHandler Disqualified;
}
