// ProductDriver.cs

using System;

public class ProductDriver
{
  	private static InputWrapper iw = new InputWrapper(); 
	public static void Loop()
	{
		Console.WriteLine("Enter command, quit to exit");
		string cmd = iw.getString("product> ");
		while (! cmd.Equals("quit"))
		{
			try
			{
				if (cmd.Equals("list"))
				{
					Display(Game.iprods);
				}
				else if (cmd.Equals("add"))
				{
					string name = iw.getString("name: ");
					int qty = iw.getInt("quantity: ");
					decimal price = iw.getDecimal("price: ");
					string status = Game.iprods.AddProduct(name, qty, price);
					Console.WriteLine(status);
				}
				else if (cmd.Equals("delete"))
				{
					string name = iw.getString("name: ");
					string status = Game.iprods.DeleteProduct(name);
					Console.WriteLine(status);
				}
				else if (cmd.Equals("find"))
				{
					string name = iw.getString("name: ");
					Product itm = Game.iprods.FindProduct(name);
					if (itm == null)
						Console.WriteLine("Product not found");
					else
						Console.WriteLine(itm.ToString());
				}
				else if (cmd.Equals("changeq"))
				{
					string name = iw.getString("name: ");
					int delta = iw.getInt("delta: ");
					string status = Game.iprods.ChangeQuantity(name, delta);
					Console.WriteLine(status);
				}
				else if (cmd.Equals("changep"))
				{
					string name = iw.getString("name: ");
					decimal delta = iw.getDecimal("delta: ");
					string status = Game.iprods.ChangePrice(name, delta);
					Console.WriteLine(status);
				}
				else if (cmd.Equals("sell"))
				{
					string name = iw.getString("name: ");
					int qty = iw.getInt("quantity: ");
					decimal price;
					string status = Game.whole.Sell(name, qty, out price);
					if (status == "OK")
						Console.WriteLine("{0} sold at price of {1:C}", qty, price);
					else
						Console.WriteLine(status);
				}
				else
					help();
			}
			catch (Exception e)
			{
				Console.WriteLine("Exception: {0}", e.Message);
			}
			cmd = iw.getString("product> ");
		}
	}

	public static void Display(IProductList prods)
	{
		Console.WriteLine("Vendor name = {0}", Game.ivendname.VendorName);
		Console.WriteLine("Count = {0}", prods.Count);
		foreach (Product prod in prods.GetProducts())
		{
			Console.WriteLine(prod.ToString());
		}							   
	}

	private static void help()
	{
		Console.WriteLine("The following commands are available:");
		Console.WriteLine("\tlist    -- list products");
		Console.WriteLine("\tadd     -- add a product");
		Console.WriteLine("\tdelete  -- delete a product");
		Console.WriteLine("\tfind    -- find a product");
		Console.WriteLine("\tchangeq -- change quantity");
		Console.WriteLine("\tchangep -- change price");
		Console.WriteLine("\tsell    -- sell a product at wholesale");
		Console.WriteLine("\tquit    -- exit the driver");
	}
}