using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace GuiGameClient
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Button cmdShopper;
		private System.Windows.Forms.TextBox txtName;
		private System.Windows.Forms.TextBox txtPassword;
		private System.Windows.Forms.Button cmdVendor;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.cmdShopper = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.txtName = new System.Windows.Forms.TextBox();
			this.txtPassword = new System.Windows.Forms.TextBox();
			this.cmdVendor = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// cmdShopper
			// 
			this.cmdShopper.Location = new System.Drawing.Point(24, 112);
			this.cmdShopper.Name = "cmdShopper";
			this.cmdShopper.Size = new System.Drawing.Size(96, 23);
			this.cmdShopper.TabIndex = 0;
			this.cmdShopper.Text = "Shopper Login";
			this.cmdShopper.Click += new System.EventHandler(this.cmdShopper_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(32, 24);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(56, 23);
			this.label1.TabIndex = 1;
			this.label1.Text = "Name";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(32, 64);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(56, 23);
			this.label2.TabIndex = 2;
			this.label2.Text = "Password";
			// 
			// txtName
			// 
			this.txtName.Location = new System.Drawing.Point(104, 24);
			this.txtName.Name = "txtName";
			this.txtName.TabIndex = 3;
			this.txtName.Text = "";
			// 
			// txtPassword
			// 
			this.txtPassword.Location = new System.Drawing.Point(104, 64);
			this.txtPassword.Name = "txtPassword";
			this.txtPassword.PasswordChar = '*';
			this.txtPassword.TabIndex = 4;
			this.txtPassword.Text = "";
			// 
			// cmdVendor
			// 
			this.cmdVendor.Location = new System.Drawing.Point(144, 112);
			this.cmdVendor.Name = "cmdVendor";
			this.cmdVendor.Size = new System.Drawing.Size(96, 23);
			this.cmdVendor.TabIndex = 5;
			this.cmdVendor.Text = "Vendor Login";
			this.cmdVendor.Click += new System.EventHandler(this.cmdVendor_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 181);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.cmdVendor,
																		  this.txtPassword,
																		  this.txtName,
																		  this.label2,
																		  this.label1,
																		  this.cmdShopper});
			this.Name = "Form1";
			this.Text = "The Electronic Commerce Game";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void cmdShopper_Click(object sender, System.EventArgs e)
		{
			ShopperForm frmShopper = new ShopperForm();
			Player p;
			string status = Game.players.Login(txtName.Text, txtPassword.Text, out p);
			if (status == "OK")
			{
				if (p.GetType() == typeof(Shopper))
				{
					if (status == "OK")
					{
						Game.CurrentShopper = (Shopper) p;
						frmShopper.Text += " - " + p.Name;
						frmShopper.txtBalance.Text = 
							string.Format("{0:C}", p.Balance);
						frmShopper.Show();
					}
					else
						MessageBox.Show(status, "Commerce Game");
				}
				else
				{
					string result = Game.players.Logout(txtName.Text);
					if (result == "OK")
						MessageBox.Show("Not a shopper - Logged out", "Commerce Game");
					else
						MessageBox.Show("Not a shopper - " + result, "Commerce Game");
				}
			}
			else
				MessageBox.Show(status, "Commerce Game");
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			try
			{
				Game.InitGame();
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message, "Commerce Game");
				return;
			}
			// for testing
			//txtName.Text = "Toyland";
			//txtPassword.Text = "ttt";
		}

		private void cmdVendor_Click(object sender, System.EventArgs e)
		{
			VendorForm frmVendor = new VendorForm();
			Player p;
			string status = Game.players.Login(txtName.Text, txtPassword.Text, out p);
			if (status == "OK")
			{
				if (p.GetType() == typeof(Vendor))
				{
					if (status == "OK")
					{
						Game.CurrentVendor = (Vendor) p;
						frmVendor.Text += " - " + p.Name;
						frmVendor.txtBalance.Text = 
							string.Format("{0:C}", p.Balance);
						frmVendor.Show();
					}
					else
						MessageBox.Show(status, "Commerce Game");
				}
				else
				{
					string result = Game.players.Logout(txtName.Text);
					if (result == "OK")
						MessageBox.Show("Not a vendor - Logged out", "Commerce Game");
					else
						MessageBox.Show("Not a vendor - " + result, "Commerce Game");
				}
			}
		}
	}
}
