using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace GuiGameClient
{
	/// <summary>
	/// Summary description for ShopperForm.
	/// </summary>
	public class ShopperForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button cmdLogout;
		private System.Windows.Forms.Label label1;
		internal System.Windows.Forms.TextBox txtBalance;
		private System.Windows.Forms.ListView lvShopping;
		private System.Windows.Forms.ColumnHeader colItem;
		private System.Windows.Forms.ColumnHeader colQty;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox txtUrl;
		private System.Windows.Forms.Button cmdVisit;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ShopperForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.cmdLogout = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.txtBalance = new System.Windows.Forms.TextBox();
			this.lvShopping = new System.Windows.Forms.ListView();
			this.colItem = new System.Windows.Forms.ColumnHeader();
			this.colQty = new System.Windows.Forms.ColumnHeader();
			this.label2 = new System.Windows.Forms.Label();
			this.txtUrl = new System.Windows.Forms.TextBox();
			this.cmdVisit = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// cmdLogout
			// 
			this.cmdLogout.Location = new System.Drawing.Point(136, 224);
			this.cmdLogout.Name = "cmdLogout";
			this.cmdLogout.Size = new System.Drawing.Size(96, 23);
			this.cmdLogout.TabIndex = 0;
			this.cmdLogout.Text = "Logout";
			this.cmdLogout.Click += new System.EventHandler(this.cmdLogout_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(24, 24);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(56, 23);
			this.label1.TabIndex = 1;
			this.label1.Text = "Balance";
			// 
			// txtBalance
			// 
			this.txtBalance.Location = new System.Drawing.Point(88, 24);
			this.txtBalance.Name = "txtBalance";
			this.txtBalance.ReadOnly = true;
			this.txtBalance.TabIndex = 2;
			this.txtBalance.Text = "";
			// 
			// lvShopping
			// 
			this.lvShopping.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						 this.colItem,
																						 this.colQty});
			this.lvShopping.FullRowSelect = true;
			this.lvShopping.GridLines = true;
			this.lvShopping.Location = new System.Drawing.Point(24, 64);
			this.lvShopping.Name = "lvShopping";
			this.lvShopping.Size = new System.Drawing.Size(184, 97);
			this.lvShopping.TabIndex = 3;
			this.lvShopping.View = System.Windows.Forms.View.Details;
			// 
			// colItem
			// 
			this.colItem.Text = "Item";
			this.colItem.Width = 120;
			// 
			// colQty
			// 
			this.colQty.Text = "Quantity";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(24, 184);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(80, 23);
			this.label2.TabIndex = 4;
			this.label2.Text = "Vendor URL";
			// 
			// txtUrl
			// 
			this.txtUrl.Location = new System.Drawing.Point(128, 184);
			this.txtUrl.Name = "txtUrl";
			this.txtUrl.TabIndex = 5;
			this.txtUrl.Text = "";
			// 
			// cmdVisit
			// 
			this.cmdVisit.Location = new System.Drawing.Point(24, 224);
			this.cmdVisit.Name = "cmdVisit";
			this.cmdVisit.Size = new System.Drawing.Size(96, 23);
			this.cmdVisit.TabIndex = 6;
			this.cmdVisit.Text = "Visit Vendor";
			this.cmdVisit.Click += new System.EventHandler(this.cmdVisit_Click);
			// 
			// ShopperForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 273);
			this.ControlBox = false;
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.cmdVisit,
																		  this.txtUrl,
																		  this.label2,
																		  this.lvShopping,
																		  this.txtBalance,
																		  this.label1,
																		  this.cmdLogout});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Name = "ShopperForm";
			this.Text = "Shopper";
			this.Load += new System.EventHandler(this.ShopperForm_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void cmdLogout_Click(object sender, System.EventArgs e)
		{
			string name = Game.CurrentShopper.Name;
			string status = Game.players.Logout(name);
			if (status == "OK")
			{
				Game.CurrentShopper = null;
				string msg = string.Format("{0} has logged out", name);
				MessageBox.Show(msg, "Commerce Game");
			}
			else
				MessageBox.Show(status, "Commerce Game");
			Close();
		}

		private void ShopperForm_Load(object sender, System.EventArgs e)
		{
			ShowItemList();
			txtUrl.Text = "toyland.com";	// for testing
		}

		public void ShowItemList()
		{
			ShowBalance();
			IList list = Game.CurrentShopper.GetShoppingList();
			lvShopping.Items.Clear();
			foreach (Item itm in list)
			{
				ListViewItem li = new ListViewItem();
				string name = itm.Name.Trim();
				string qty = itm.Quantity.ToString().Trim();
				li.Text = name;
				li.SubItems.Add(qty);
				lvShopping.Items.Add(li);
			}
		}

		private void cmdVisit_Click(object sender, System.EventArgs e)
		{
			Game.CurrentVendor = Game.vendata.FindVendor(txtUrl.Text);
			if (Game.CurrentVendor == null)
				MessageBox.Show("Vendor not found", "Commerce Game");
			else
			{
				VisitVendor frmVendor = new VisitVendor();
				frmVendor.Text = Game.CurrentVendor.Name;
				frmVendor.ShowDialog(this);
				ShowItemList();
			}				
		}

		private void ShowBalance()
		{
			decimal bal;
			string status = Game.iplay.GetBalance(Game.CurrentShopper.Name, out bal);
			if (status != "OK")
				MessageBox.Show(status, "Commerce Game");
			else
				txtBalance.Text = string.Format("{0:C}", bal);
		}
	}
}
