using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace GuiGameClient
{
	/// <summary>
	/// Summary description for VisitVendor.
	/// </summary>
	public class VisitVendor : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ListView lvInventory;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox txtName;
		private System.Windows.Forms.TextBox txtQuantity;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Button cmdBuy;
		private System.Windows.Forms.Button cmdClose;
		private System.Windows.Forms.ColumnHeader colName;
		private System.Windows.Forms.ColumnHeader colPrice;
		private System.Windows.Forms.ColumnHeader colQty;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public VisitVendor()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.lvInventory = new System.Windows.Forms.ListView();
			this.label1 = new System.Windows.Forms.Label();
			this.txtName = new System.Windows.Forms.TextBox();
			this.txtQuantity = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.cmdBuy = new System.Windows.Forms.Button();
			this.cmdClose = new System.Windows.Forms.Button();
			this.colName = new System.Windows.Forms.ColumnHeader();
			this.colPrice = new System.Windows.Forms.ColumnHeader();
			this.colQty = new System.Windows.Forms.ColumnHeader();
			this.SuspendLayout();
			// 
			// lvInventory
			// 
			this.lvInventory.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						  this.colName,
																						  this.colPrice,
																						  this.colQty});
			this.lvInventory.GridLines = true;
			this.lvInventory.Location = new System.Drawing.Point(24, 24);
			this.lvInventory.Name = "lvInventory";
			this.lvInventory.Size = new System.Drawing.Size(248, 128);
			this.lvInventory.TabIndex = 0;
			this.lvInventory.View = System.Windows.Forms.View.Details;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(32, 168);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(72, 23);
			this.label1.TabIndex = 1;
			this.label1.Text = "Name";
			// 
			// txtName
			// 
			this.txtName.Location = new System.Drawing.Point(112, 168);
			this.txtName.Name = "txtName";
			this.txtName.TabIndex = 2;
			this.txtName.Text = "";
			// 
			// txtQuantity
			// 
			this.txtQuantity.Location = new System.Drawing.Point(112, 200);
			this.txtQuantity.Name = "txtQuantity";
			this.txtQuantity.Size = new System.Drawing.Size(56, 20);
			this.txtQuantity.TabIndex = 4;
			this.txtQuantity.Text = "";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(32, 200);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(72, 23);
			this.label2.TabIndex = 3;
			this.label2.Text = "Quantity";
			// 
			// cmdBuy
			// 
			this.cmdBuy.Location = new System.Drawing.Point(32, 240);
			this.cmdBuy.Name = "cmdBuy";
			this.cmdBuy.TabIndex = 5;
			this.cmdBuy.Text = "Buy";
			this.cmdBuy.Click += new System.EventHandler(this.cmdBuy_Click);
			// 
			// cmdClose
			// 
			this.cmdClose.Location = new System.Drawing.Point(144, 240);
			this.cmdClose.Name = "cmdClose";
			this.cmdClose.TabIndex = 6;
			this.cmdClose.Text = "Close";
			this.cmdClose.Click += new System.EventHandler(this.cmdClose_Click);
			// 
			// colName
			// 
			this.colName.Text = "Name";
			this.colName.Width = 116;
			// 
			// colPrice
			// 
			this.colPrice.Text = "Price";
			this.colPrice.Width = 67;
			// 
			// colQty
			// 
			this.colQty.Text = "Quantity";
			// 
			// VisitVendor
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(312, 285);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.cmdClose,
																		  this.cmdBuy,
																		  this.txtQuantity,
																		  this.label2,
																		  this.txtName,
																		  this.label1,
																		  this.lvInventory});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "VisitVendor";
			this.Text = "VisitVendor";
			this.Load += new System.EventHandler(this.VisitVendor_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void cmdClose_Click(object sender, System.EventArgs e)
		{
			Close();
		}

		private void ShowList(IList list)
		{
			lvInventory.Items.Clear();
			foreach (Product prod in list)
			{
				ListViewItem li = new ListViewItem();
				string name = prod.Name.Trim();
				string price = string.Format("{0:C}", prod.Price);
				string qty = prod.Quantity.ToString().Trim();
				
				li.Text = name;
				li.SubItems.Add(price);
				li.SubItems.Add(qty);
				lvInventory.Items.Add(li);
			}
		}

		private void VisitVendor_Load(object sender, System.EventArgs e)
		{
			ShowList(Game.CurrentVendor.GetProducts());
		}

		private void cmdBuy_Click(object sender, System.EventArgs e)
		{
			string prodName = txtName.Text;
			int qty = Convert.ToInt32(txtQuantity.Text);
			string status = Game.ShopperBuy(prodName, qty);
			if (status != "OK")
				MessageBox.Show(status, "Commerce Game");
			else
			{
				ShowList(Game.CurrentVendor.GetProducts());
			}
		}
	}
}
