using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace GuiGameClient
{
	/// <summary>
	/// Summary description for WholesaleForm.
	/// </summary>
	public class WholesaleForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button cmdClose;
		private System.Windows.Forms.ListView lvInventory;
		private System.Windows.Forms.ColumnHeader colName;
		private System.Windows.Forms.ColumnHeader colPrice;
		private System.Windows.Forms.ColumnHeader colQty;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public WholesaleForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.cmdClose = new System.Windows.Forms.Button();
			this.lvInventory = new System.Windows.Forms.ListView();
			this.colName = new System.Windows.Forms.ColumnHeader();
			this.colPrice = new System.Windows.Forms.ColumnHeader();
			this.colQty = new System.Windows.Forms.ColumnHeader();
			this.SuspendLayout();
			// 
			// cmdClose
			// 
			this.cmdClose.Location = new System.Drawing.Point(104, 168);
			this.cmdClose.Name = "cmdClose";
			this.cmdClose.TabIndex = 13;
			this.cmdClose.Text = "Close";
			this.cmdClose.Click += new System.EventHandler(this.cmdClose_Click);
			// 
			// lvInventory
			// 
			this.lvInventory.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						  this.colName,
																						  this.colPrice,
																						  this.colQty});
			this.lvInventory.GridLines = true;
			this.lvInventory.Location = new System.Drawing.Point(22, 17);
			this.lvInventory.Name = "lvInventory";
			this.lvInventory.Size = new System.Drawing.Size(248, 128);
			this.lvInventory.TabIndex = 7;
			this.lvInventory.View = System.Windows.Forms.View.Details;
			// 
			// colName
			// 
			this.colName.Text = "Name";
			this.colName.Width = 116;
			// 
			// colPrice
			// 
			this.colPrice.Text = "Price";
			this.colPrice.Width = 67;
			// 
			// colQty
			// 
			this.colQty.Text = "Quantity";
			// 
			// WholesaleForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 215);
			this.ControlBox = false;
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.cmdClose,
																		  this.lvInventory});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "WholesaleForm";
			this.Text = "Wholesaler";
			this.Load += new System.EventHandler(this.WholesaleForm_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void ShowProductList()
		{
			IList list = Game.whole.GetProducts();
			lvInventory.Items.Clear();
			foreach (Product prod in list)
			{
				ListViewItem li = new ListViewItem();
				string name = prod.Name.Trim();
				string price = string.Format("{0:C}", prod.Price);
				string qty = prod.Quantity.ToString().Trim();
				
				li.Text = name;
				li.SubItems.Add(price);
				li.SubItems.Add(qty);
				lvInventory.Items.Add(li);
			}
		}

		private void WholesaleForm_Load(object sender, System.EventArgs e)
		{
			ShowProductList();
		}

		private void cmdClose_Click(object sender, System.EventArgs e)
		{
			Close();
		}
	}
}
