// Game.cs

using System.Collections;

public class Game
{
	public const decimal StartBalance = 5000m;
	public static IPlayer players = new PlayerDb();
	public static Shopper CurrentShopper = null;
	public static Vendor CurrentVendor = null;
	public static Wholesaler Supplier = new Wholesaler();

	public static string ShopperBuy(string prodName, int qty)
	{
		decimal price;
		string status = CurrentVendor.Sell(prodName, qty, out price);
		if (status != "OK")
			return status;
		else
		{
			status = players.ChangeBalance(CurrentShopper.Name, -qty*price);
			if (status == "OK")
			{
				IItemList ilist = CurrentShopper.Items;
				status = ilist.ChangeQuantity(prodName, -qty);
				if (status != "OK")
					return status;
				else
					return "OK";
			}
			else
				return status;
		}
	}

	public static string VendorBuy(string prodName, int qty)
	{
		decimal price;
		string status = Supplier.Sell(prodName, qty, out price);
		if (status != "OK")
			return status;
		else
		{
			status = players.ChangeBalance(CurrentVendor.Name, -qty*price);
			if (status == "OK")
			{
				IProductList list = CurrentVendor.Products;
				status = list.ChangeQuantity(prodName, qty);
				if (status != "OK")
					return status;
				else
					return "OK";
			}
			else
				return status;
		}
	}
}