// GameDriver.cs

using System;

public class GameDriver
{
  	private static InputWrapper iw = new InputWrapper(); 
	public static void Main()
	{
		Console.WriteLine("Enter command, quit to exit");
		string cmd = iw.getString(": ");
		while (! cmd.Equals("quit"))
		{
			if (cmd.Equals("shopper"))
			{
				Console.WriteLine("Please login");
				string name = iw.getString("name: ");
				string pwd = iw.getString("password: ");
				Player p;
				string status = Game.players.Login(name, pwd, out p);
				if (status == "OK")
				{
					if (p.GetType() == typeof(Shopper))
					{
						// Give the player fresh starting balance
						status = Game.players.SetBalance(name, Game.StartBalance);
						p.Balance = Game.StartBalance;
						if (status == "OK")
						{
							Console.WriteLine("Welcome, {0}", p.Name);
							Console.WriteLine("Your balance is {0}", p.Balance);
							ShopperDriver.Loop((Shopper) p);
						}
						else
							Console.WriteLine(status);
					}
					else
					{
						Console.WriteLine("Not a shopper");
						string result = Game.players.Logout(name);
						if (result == "OK")
							Console.WriteLine("Logged out");
						else
							Console.WriteLine(result);
					}
				}
				else
					Console.WriteLine(status);
			}
			else if (cmd.Equals("vendor"))
			{
				Console.WriteLine("Please login");
				string name = iw.getString("name: ");
				string pwd = iw.getString("password: ");
				Player p;
				string status = Game.players.Login(name, pwd, out p);
				if (status == "OK")
				{
					if (p.GetType() == typeof(Vendor))
					{
						Console.WriteLine("Welcome, {0}", p.Name);
						Console.WriteLine("Your balance is {0}", p.Balance);
						VendorDriver.Loop((Vendor) p);
					}
					else
					{
						Console.WriteLine("Not a vendor");
						string result = Game.players.Logout(name);
						if (result == "OK")
							Console.WriteLine("Logged out");
						else
							Console.WriteLine(result);
					}
				}
				else
					Console.WriteLine(status);
			}
			else if (cmd.Equals("player"))
			{
				PlayerAdmin.Loop();
			}
			else if (cmd.Equals("product"))
			{
				ProductAdmin.Loop();
			}
			else
				help();
			cmd = iw.getString(": ");
		}
	}
	private static void help()
	{
		Console.WriteLine("The following commands are available:");
		Console.WriteLine("\tshopper -- shopper driver");
		Console.WriteLine("\tvendor  -- vendor driver");
		Console.WriteLine("\tplayer  -- player admin");
		Console.WriteLine("\tproduct -- product admin");
		Console.WriteLine("\tquit    -- exit the program");
	}
}