// Item.cs

using System;
using System.Collections;

public class Item
{
	public string Name;
	public int Quantity;
	public Item(string n, int qty)
	{
		Name = n;
		Quantity = qty;
	}
	public string Show()
	{
		return string.Format("{0, -15}  {1,10}", Name, Quantity);
	}
}

public class ItemList : IItemList
{
	private ArrayList m_list = new ArrayList();
	public int Count
	{
		get
		{
			return m_list.Count;
		}
	}

	public string AddItem(string name, int qty)
	{
		if (FindItem(name) != null)
			return "Item " + name + " is already on list";
		else
		{
			Item itm = new Item(name, qty);
			m_list.Add(itm);
			return "OK";
		}
	}

	public string DeleteItem(string name)
	{
		if (Count == 0)
			return "List is empty";
		Item itm = FindItem(name);
		if (itm == null)
			return "Item not found";
		else
		{
			m_list.Remove(itm);
			return "OK";
		}
	}

	public Item FindItem(string name)
	{
		foreach (Item itm in m_list)
		{
			if (itm.Name == name)
				return itm;
		}
		return null;
	}

	public string ChangeQuantity(string name, int delta)
	{
		Item itm = FindItem(name);
		if (itm == null)
			return "Not found";
		else
		{
			itm.Quantity += delta;
			return "OK";
		}
	}

	public IList GetItems()
	{
		return m_list;
	}
}