// PlayerAdmin.cs

using System;
using System.Collections;

public class PlayerAdmin
{
  	private static InputWrapper iw = new InputWrapper(); 
	private static PlayerDb players = new PlayerDb();
	private static IVendorAdmin m_vendorAdmin = new VendorData();
	public static void Loop()
	{
		Console.WriteLine("Enter command, quit to exit");
		string cmd = iw.getString("player> ");
		while (! cmd.Equals("quit"))
		{
			try
			{
				if (cmd.Equals("login"))
				{
					string name = iw.getString("name: ");
					string pwd = iw.getString("password: ");
					Player p;
					string status = players.Login(name, pwd, out p);
					if (status == "OK")
					{
						Console.WriteLine("Welcome, {0}", p.Name);
						Console.WriteLine("Your balance is {0}", p.Balance);
					}
					else
						Console.WriteLine(status);
				}
				else if (cmd.Equals("logout"))
				{
					string name = iw.getString("name: ");
					string status = players.Logout(name);
					if (status == "OK")
						Console.WriteLine("{0} has logged out", name);
					else
						Console.WriteLine(status);
				}
				else if (cmd.Equals("add"))
				{
					string name = iw.getString("name: ");
					string pwd = iw.getString("password: ");
					decimal bal = iw.getDecimal("balance: ");
					int roleId = iw.getInt("role (Shopper = 1, Vendor = 2): ");
					string status = players.AddPlayer(name, pwd, bal, roleId);
					if (status == "OK")
					{
						Console.WriteLine("{0} has been added", name);
						if (roleId == (int) PlayerRole.Vendor)
						{
							string url = iw.getString("url: ");
							status = m_vendorAdmin.AddUrl(name, url);
							if (status == "OK")
								Console.WriteLine("Url has been added");
							else
								Console.WriteLine(status);
						}
					}
					else
						Console.WriteLine(status);
				}
				else if (cmd.Equals("delete"))
				{
					string name = iw.getString("name: ");
					Player play = players.FindPlayer(name);
					if (play == null)
						Console.WriteLine("Player not found");
					else
					{
						string status = players.DeletePlayer(name);
						Console.WriteLine(status);
						if (status == "OK")
						{
							if (play.GetType() == typeof(Vendor))
							{
								status = m_vendorAdmin.DeleteUrl(name);
								Console.WriteLine(status);
							}
						}
					}
				}
				else if (cmd.Equals("find"))
				{
					string name = iw.getString("name: ");
					Player play = players.FindPlayer(name);
					if (play == null)
						Console.WriteLine("Player not found");
					else
						Console.WriteLine(play.Show());
				}
				else if (cmd.Equals("list"))
				{
					Console.WriteLine("Count = {0}", players.Count);
					Display(players);
				}
				else
					help();
			}
			catch (Exception e)
			{
				Console.WriteLine("Exception: {0}", e.Message);
			}
			cmd = iw.getString("player> ");
		}
	}

	public static void Display(PlayerDb players)
	{
		IList list = players.GetPlayers();
		foreach (Player p in list)
		{
			Console.WriteLine(p.Show());
		}							   
	}

	private static void help()
	{
		Console.WriteLine("The following commands are available:");
		Console.WriteLine("\tlogin   -- login a player");
		Console.WriteLine("\tlogout  -- logout a player");
		Console.WriteLine("\tadd     -- add a new player");
		Console.WriteLine("\tdelete  -- delete a player");
		Console.WriteLine("\tlist    -- list player information");
		Console.WriteLine("\tquit    -- exit the program");
	}
}