// ProductAdmin.cs

using System;
using System.Data;
using System.Data.OleDb;
using System.Collections;

public class ProductAdmin
{
	private static string VendorName = "Toyland";
  	private static InputWrapper iw = new InputWrapper(); 

	public static void Loop()
	{
		ProductDb prods = new ProductDb(VendorName);
		VendorData vend = new VendorData();
		Console.WriteLine("Enter command, quit to exit");
		string cmd = iw.getString("prod> ");
		while (! cmd.Equals("quit"))
		{
			try
			{
				if (cmd.Equals("list"))
				{
					Console.WriteLine("Vendor = {0}", VendorName);
					Console.WriteLine("Count = {0}", prods.Count);
					ShowList(prods.GetProducts());
				}
				else if (cmd.Equals("add"))
				{
					string name = iw.getString("name: ");
					int qty = iw.getInt("quantity: ");
					decimal price = iw.getDecimal("price: ");
					string status = prods.AddProduct(name, qty, price);
					Console.WriteLine(status);
				}
				else if (cmd.Equals("delete"))
				{
					string name = iw.getString("name: ");
					string status = prods.DeleteProduct(name);
					Console.WriteLine(status);
				}
				else if (cmd.Equals("find"))
				{
					string name = iw.getString("name: ");
					Product itm = prods.FindProduct(name);
					if (itm == null)
						Console.WriteLine("Product not found");
					else
						Console.WriteLine(itm.Show());
				}
				else if (cmd.Equals("changeq"))
				{
					string name = iw.getString("name: ");
					int delta = iw.getInt("delta: ");
					string status = prods.ChangeQuantity(name, delta);
					Console.WriteLine(status);
				}
				else if (cmd.Equals("changep"))
				{
					string name = iw.getString("name: ");
					decimal delta = iw.getDecimal("delta: ");
					string status = prods.ChangePrice(name, delta);
					Console.WriteLine(status);
				}
				else if (cmd.Equals("vendor"))
				{
					string name = iw.getString("name: ");
					string url = vend.FindUrl(name);
					if (url == null)
						Console.WriteLine("Vendor not found");
					else
					{
						VendorName = name;
						prods = new ProductDb(VendorName);
					}
				}
				else
					help();
			}
			catch (Exception e)
			{
				Console.WriteLine("Exception: {0}", e.Message);
			}
			cmd = iw.getString("prod> ");
		}
	}

	private static void ShowList(IList list)
	{
		foreach (Product prod in list)
			Console.WriteLine(prod.Show());
	}

	private static void help()
	{
		Console.WriteLine("The following commands are available:");
		Console.WriteLine("\tlist    -- list products");
		Console.WriteLine("\tadd     -- add a product");
		Console.WriteLine("\tdelete  -- delete a product");
		Console.WriteLine("\tfind    -- find a product");
		Console.WriteLine("\tchangeq -- change quantity");
		Console.WriteLine("\tchangep -- change price");
		Console.WriteLine("\tvendor  -- new vendor");
		Console.WriteLine("\tquit    -- exit the program");
	}
}